; example2.nsi
;
; This script is based on example1.nsi, but it remember the directory,
; has uninstall support and (optionally) installs start menu shortcuts.
;
; It will install makensisw.exe into a directory that the user selects,

;--------------------------------

; The name of the installer
Name "PMTG V1.2"

; The file to write
OutFile "iservpmtg.exe"

; The default installation directory
InstallDir $PROGRAMFILES\SERVPMTG

; Registry key to check for directory (so if you install again, it will
; overwrite the old one automatically)
InstallDirRegKey HKLM "Software\SERVPMTG" ""

;--------------------------------

; Pages

Page directory
Page instfiles

UninstPage uninstConfirm
UninstPage instfiles

;--------------------------------

; The stuff to install
Section "SERVPMTG"

  SectionIn RO

  ; Set output path to the installation directory.
  SetOutPath $INSTDIR

  ; Put file there
  File "servpmtg.exe"
  File "pmtg.dll"

  ; Write the installation path into the registry
  WriteRegStr HKLM SOFTWARE\SERVPMTG "Install_Dir" "$INSTDIR"

  ; Write the uninstall keys for Windows
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\SC501TXT" "DisplayName" "SERVPMTG V1.2"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\SC501TXT" "UninstallString" '"$INSTDIR\uninstall.exe"'
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\SC501TXT" "NoModify" 1
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\SC501TXT" "NoRepair" 1
  WriteUninstaller "uninstall.exe"

SectionEnd

; Optional section (can be disabled by the user)
Section "Atalho do Menu Iniciar"

  CreateDirectory "$SMPROGRAMS\MicroTerminal Gertec"
  CreateShortCut "$SMPROGRAMS\MicroTerminal Gertec\Uninstall.lnk" "$INSTDIR\uninstall.exe" "" "$INSTDIR\uninstall.exe" 0
  CreateShortCut "$SMPROGRAMS\MicroTerminal Gertec\SERVPMTG.lnk" "$INSTDIR\servpmtg.exe" "" "$INSTDIR\servpmtg.exe" 0

SectionEnd

;--------------------------------

; Uninstaller

Section "Uninstall"

  ; Remove registry keys
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\SERVPMTG"
  DeleteRegKey HKLM SOFTWARE\SERVPMTG

  ; Remove files and uninstaller
  Delete "$INSTDIR\*.*"

  ; Remove shortcuts, if any
  Delete "$SMPROGRAMS\MicroTerminal Gertec\*.*"

  ; Remove directories used
  RMDir "$SMPROGRAMS\MicroTerminal Gertec"
  RMDir "$INSTDIR"

SectionEnd