
#ifndef STRUCTS_H
#define STRUCTS_H

#pragma pack(push)
#pragma pack(1)

typedef struct {
  unsigned short ID;
  unsigned short TamArg;
} CMDHEADER;

typedef struct {
  unsigned char card[128]; // Dados da trilhas 80 trilha 1 e 41 trilha 2
  unsigned long status;
}ARG_CARD; // Argumento do Cartao

typedef struct {
  unsigned char cod[512];
}ARG_CODE; // Argumento de Codigo

typedef struct {
 unsigned char cArg1;
 unsigned char cArg2;
}ARG_BYTE_BYTE; // Argumento de Funcao (BYTE,BYTE) ou (CHAR,CHAR)

typedef struct {
 unsigned char cArg1;
 unsigned long bArg2;
}ARG_BYTE_BOOL; // Argumento de Funcao (BYTE,BOOL)

typedef struct
{
  unsigned long  baud;       /* 300 a 115.200 bauds; */
  unsigned short  bits;      /* data bits */
  unsigned short  parity;    /* see below */
  unsigned short  stops;     /* stop bits 1 or 2 */
  unsigned char handshaking; /* 0 -> none handshaking  1 -> RTS/CTS */
} TSetupSerial;

typedef struct {
 unsigned char Com;
 TSetupSerial Setup;
}ARG_COM_SETUPSERIAL;

typedef struct {
 unsigned char Com;
 unsigned char Bin[256];
 unsigned char Tam;
}ARG_COM_BIN_BYTE;

typedef struct {
 unsigned char String[41];
}ARG_STR; // Argumento da Funcao (String)

typedef struct {
 unsigned char String[255];
 unsigned char tam;
}ARG_STR_BYTE; // Argumento da Funcao (String,BYTE tam)

typedef struct {
 unsigned char String[41];
 unsigned long status;
}ARG_STR_BOOL; // Argumento da Funcao (String,BOOL)

typedef struct {
 unsigned char String[41];
 unsigned long bOnOff;
 unsigned long bPassWord;
}ARG_STR_BOOL_BOOL; // Argumento da Funcao (String,BOOL,BOOL)

typedef struct{
  unsigned long microT_IP; // Equivale DWORD 32bits -> IPv4
  unsigned long server_IP;
  unsigned long msknet_IP;
  unsigned long bDHCP;
}TSetupTCP;

typedef struct{
  unsigned long gateway;
  unsigned long nameserver;
  char myname[16];
}TExSetupTCP;

typedef struct{
  char updserver[100];
  char upduser[30];
  char updpass[30];
}TSetupUpdate;

typedef union {   // Argumento em Geral ocupando o mesmo espaco de memoria
  ARG_CARD             aCard;
  ARG_CODE             aCode;
  ARG_BYTE_BYTE        aByteByte;
  ARG_BYTE_BOOL        aByteBool;
  ARG_COM_SETUPSERIAL  aSetupSerial;
  ARG_COM_BIN_BYTE     aBinSerial;
  ARG_STR              aStr;
  ARG_STR_BYTE         aStrByte;
  ARG_STR_BOOL         aStrBool;
  ARG_STR_BOOL_BOOL    aStrBoolBool;
  TSetupTCP            aSetupTcp;
  TExSetupTCP          aExSetupTCP;
  TSetupUpdate         aSetupUpdate;
  unsigned long        Dword;
  unsigned short       Word;
  unsigned char        Byte;
} ARGUMENT;

//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
typedef struct
{
  unsigned char sMacADD[6];
  char sMyName[32];
} ARG_UID;

typedef struct {
  unsigned char STX;
  unsigned short ID;
  unsigned long TamArg;
  unsigned long obool;
} ARG_BOOL;

typedef struct {
  unsigned short wTamBuff;
  unsigned char sBuffer[256];
} ARG_SERIAL_DATA;

typedef struct {
  char sTrack1[128];
  char sTrack2[128];
  char sTrack3[128];
  unsigned long dwStatus;
} ARG_CARD_LEC;

typedef struct {
  unsigned short wPosX;
  unsigned short wPosY;
  char sText[128];
  char sFont[32];
  unsigned short wSize;
  unsigned short wColor;
  unsigned short wBGColor;
} ARG_DISPALY_TEXT;

typedef struct {
  unsigned long dwOpen;
  unsigned long dwBaud;
  unsigned char bParity;
  unsigned char bDataBits;
  unsigned short wTimeOut;
} ARG_SERIAL_CFG;

typedef struct {
  unsigned long dwMY_IP_ADD;
  unsigned long dwServer_IP;
  unsigned long dwNetMask;
  unsigned long dwGateway;
  unsigned long dwNameServer;
  char TCName[32];
  unsigned short wPortsv;
  char FTPs[100];
  char FTPu[30];
  char FTPp[30];
  unsigned long dwDHCP;
  unsigned long dwSearchServer;
} ARG_SETUP_TCP;

typedef struct
{
  long imgupdenable;
  char imgupdserver[100];
  long imgupddeftime;
  long imgupdcurtime;
  //long imgupdelapstime;
} ARG_IMGUPD;

typedef struct
{
  unsigned short PosX;
  unsigned short PosY;
  unsigned short Width;
  unsigned short Height;
} ARG_IMGBLOCK;

typedef struct
{
  char FileName[128];
  unsigned long dwStatus;
} ARG_GETFILENAME;

typedef struct
{
    int TabSock[1024];
    DWORD TabIP[1024];
    int NumSockConec;
} TTABSOCK;
typedef TTABSOCK *PTABSOCK;

#pragma pack(pop)

#endif /*STRUCTS_H*/

