// SERVIDOR COM SUPORTE AOS MICROTERMINAIS: GE 750, GE 760, MT 740, MT720

unit Unit1;

// INTERFACE

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls, Winsock, Grids;

// DECLARAO DE TIPOS, COMPONENTES, PROCEDURES E FUNES GERAIS

type TTABSOCK = packed record
    TSOCK: array [0..255] of DWORD;
end;

type TSetupTCP = packed record
    microT_IP: DWORD; // Endereo IP do terminal
    server_IP: DWORD; // Endereo IP do servidor
    msknet_IP: DWORD; // Mscara de rede
    bDHCP: DWORD; // 1 = IP dinmico, 0 = IP fixo
end;

type TExSetupTCP = packed record
    gateway: DWORD; // IP do gateway
    nameserver: DWORD; // IP do servidor de nomes
    myname: array [1..16] of BYTE; // Nome do terminal
end;

type TSetupSerial = packed record
    baud: DWORD; // Baud Rate: 1200 a 115.200
    bits: WORD; // Data Bits
    parity: WORD; // Paridade
    stops: WORD; // Stop Bits
    handshaking: BYTE; // 0 = Sem Hand Shaking, 1 = RTS/CTS
end;

type ARG_COM_SETUPSERIAL = packed record
    com: BYTE;
    Setup: TSetupSerial;
end;

type ARG_CARD = packed record
    card: array [0..128] of BYTE;
    status: DWORD;
end;

type
    TForm1 = class(TForm)
    Serial: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    ListBox1: TListBox;
    btnRestart: TButton;
    btnFTPMode: TButton;
    btnClear: TButton;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    edtClienteIP: TEdit;
    edtServerIP: TEdit;
    edtNetMask: TEdit;
    chkDynamicIP: TCheckBox;
    btnEnviarConfNet: TButton;
    btnReceberConfNet: TButton;
    GroupBox2: TGroupBox;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    edtGateWay: TEdit;
    edtNameServer: TEdit;
    edtTCName: TEdit;
    btnEnviarConfExNet: TButton;
    btnReceberConfExNet: TButton;
    btnBackSpace: TButton;
    btnCarRet: TButton;
    btnFormFeed: TButton;
    btnLineFeed: TButton;
    btnGoToXY: TButton;
    btnGoToXYRef: TButton;
    btnDispStr: TButton;
    btnDispChar: TButton;
    edtGoToXY1: TEdit;
    edtGoToXY2: TEdit;
    edtGoToXYRef2: TEdit;
    edtGoToXYRef1: TEdit;
    btnDispClrLn: TButton;
    edtDispStr: TEdit;
    edtDispChar: TEdit;
    edtDispClrLn: TEdit;
    GroupBox3: TGroupBox;
    GroupBox4: TGroupBox;
    edtString: TEdit;
    chkPassWord: TCheckBox;
    btnHabilitaString: TButton;
    btnDesabilitaString: TButton;
    btnStatus: TButton;
    chkEco: TCheckBox;
    Button23: TButton;
    TabSheet4: TTabSheet;
    GroupBox7: TGroupBox;
    GroupBox8: TGroupBox;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    cbPorta: TComboBox;
    cbBaud: TComboBox;
    cbBits: TComboBox;
    cbParidade: TComboBox;
    cbStop: TComboBox;
    cbHand: TComboBox;
    btnHabilitaSerial: TButton;
    btnDesabilitaSerial: TButton;
    btnSendBinSerial: TButton;
    btnGetEnableSerial: TButton;
    edtSendBinSerial: TEdit;
    GroupBox9: TGroupBox;
    rdAtivaByte: TRadioButton;
    rdDesativaByte: TRadioButton;
    edtByte: TEdit;
    Label13: TLabel;
    btnSolicitaPeso: TButton;
    btnEnviarConfSerial: TButton;
    btnRecebeConfSerial: TButton;
    TabSheet5: TTabSheet;
    GroupBox10: TGroupBox;
    btnHabilitarCartao: TButton;
    btnDesabilitarCartao: TButton;
    btnGetCard: TButton;
    edtCartao: TEdit;
    Timer1: TTimer;
    ListReceive: TListBox;
    btnAtualizar: TButton;
    GroupBox12: TGroupBox;
    btnReset: TButton;
    btnGrava20: TButton;
    btnGrava44: TButton;
    btnBeepOn: TButton;
    btnBeepOff: TButton;
    btnBeepKeyOn: TButton;
    btnBeepKeyOff: TButton;
    GroupBox5: TGroupBox;
    GroupBox6: TGroupBox;
    GroupBox13: TGroupBox;
    rdDesativado1: TRadioButton;
    rdAtivado2: TRadioButton;
    rdDesativado2: TRadioButton;
    rdAtivado3: TRadioButton;
    rdDesativado3: TRadioButton;
    btnGetEnableKey: TButton;
    btnGetCapsLock: TButton;
    btnGetNumLock: TButton;
    rdAtivado1: TRadioButton;
    rdString: TRadioButton;
    rdByte: TRadioButton;
    OpenDialog1: TOpenDialog;
    Timer2: TTimer;
    procedure WndProc(var Message : TMessage); override;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure btnAtualizarClick(Sender: TObject);
    procedure btnRestartClick(Sender: TObject);
    procedure btnFTPModeClick(Sender: TObject);
    procedure btnClearClick(Sender: TObject);
    procedure btnReceberConfNetClick(Sender: TObject);
    procedure btnEnviarConfNetClick(Sender: TObject);
    procedure btnReceberConfExNetClick(Sender: TObject);
    procedure btnEnviarConfExNetClick(Sender: TObject);
    procedure btnBackSpaceClick(Sender: TObject);
    procedure btnCarRetClick(Sender: TObject);
    procedure btnFormFeedClick(Sender: TObject);
    procedure btnLineFeedClick(Sender: TObject);
    procedure btnGoToXYClick(Sender: TObject);
    procedure btnGoToXYRefClick(Sender: TObject);
    procedure btnDispStrClick(Sender: TObject);
    procedure btnDispCharClick(Sender: TObject);
    procedure btnDispClrLnClick(Sender: TObject);
    procedure btnHabilitaStringClick(Sender: TObject);
    procedure btnDesabilitaStringClick(Sender: TObject);
    procedure btnStatusClick(Sender: TObject);
    procedure rdAtivado1Click(Sender: TObject);
    procedure rdDesativado1Click(Sender: TObject);
    procedure btnGetEnableKeyClick(Sender: TObject);
    procedure rdAtivado2Click(Sender: TObject);
    procedure rdDesativado2Click(Sender: TObject);
    procedure btnGetCapsLockClick(Sender: TObject);
    procedure rdAtivado3Click(Sender: TObject);
    procedure rdDesativado3Click(Sender: TObject);
    procedure btnGetNumLockClick(Sender: TObject);
    procedure btnResetClick(Sender: TObject);
    procedure btnBeepOnClick(Sender: TObject);
    procedure btnBeepOffClick(Sender: TObject);
    procedure btnBeepKeyOnClick(Sender: TObject);
    procedure btnBeepKeyOffClick(Sender: TObject);
    procedure btnHabilitaSerialClick(Sender: TObject);
    procedure btnDesabilitaSerialClick(Sender: TObject);
    procedure btnGetEnableSerialClick(Sender: TObject);
    procedure btnSendBinSerialClick(Sender: TObject);
    procedure btnEnviarConfSerialClick(Sender: TObject);
    procedure btnRecebeConfSerialClick(Sender: TObject);
    procedure rdAtivaByteClick(Sender: TObject);
    procedure rdDesativaByteClick(Sender: TObject);
    procedure btnSolicitaPesoClick(Sender: TObject);
    procedure btnHabilitarCartaoClick(Sender: TObject);
    procedure btnDesabilitarCartaoClick(Sender: TObject);
    procedure btnGetCardClick(Sender: TObject);
    procedure btnGrava44Click(Sender: TObject);
    procedure btnGrava20Click(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

//  VARIVEIS

Const IDvLive = 2;

Const IDvGetSetupTCP = 8;
Const IDvGetExSetupTCP = 84;

Const IDvBackSpace = 34;
Const IDvCarRet = 36;
Const IDvLineFeed = 38;
Const IDvFormFeed = 40;
Const IDvGoToXY = 42;
Const IDvGoToXYRef = 44;
Const IDvDispStr = 52;
Const IDvDispCh = 54;
Const IDvDispClrLn = 56;
Const IDvSetEditString = 48;
Const IDbGetEditString = 50;
Const IDbReadEditString = 45;

Const IDcGetCharTerm = 29;
Const IDvSetEnableKey = 16;
Const IDbGetEnableKey = 18;
Const IDvSetCapsLock = 22;
Const IDbGetCapsLock = 24;
Const IDvSetNumLock = 26;
Const IDbGetNumLock = 28;
Const IDvReset = 20;
Const IDvSetBeep = 94;
Const IDvSetBeepKey = 96;

Const IDvSetEnableSerial = 58;
Const IDbGetEnableSerial = 60;
Const IDbSetSetupSerial = 66;
Const IDvGetSetupSerial = 68;
Const IDbGetBinSerial = 61;

Const IDvSetCard = 10;
Const IDbGetCard = 12;
Const IDbReadBuffCard = 13;

var
  Form1: TForm1;
  MsgReceiveData: LONGINT;
  // CONNECT_MSG: LONGINT;

implementation

var
    tabcon: TTABSOCK;
    auxIP: TINADDR;
    id_selecionado: Integer;

{$R *.DFM}

//  DECLARAO DE FUNES E ROTINAS

// INICIALIZAO E FINALIZAO
function mt_startserver(mywhnd: HWND; conecmsg: DWORD; commumsg: DWORD): DWORD; far; stdcall; external 'pmtg.dll';
procedure mt_finishserver; far; stdcall; external 'pmtg.dll';
function mt_connectlist: TTABSOCK; far; stdcall; external 'pmtg.dll';

// FUNES DE TRATAMENTO DE IP
function mt_inet_ntoa_inv(oip: DWORD): PChar; far; stdcall; external 'pmtg.dll';
function mt_inet_addr_inv(oip: String): DWORD; far; stdcall; external 'pmtg.dll';

// COMANDOS BSICOS PARA O TERMINAL
function mt_sendlive(id: DWORD): DWORD; far; stdcall; external 'pmtg.dll';
function mt_restart(id: DWORD): DWORD; far; stdcall; external 'pmtg.dll';
function mt_ftpmode(id: DWORD): DWORD; far; stdcall; external 'pmtg.dll';

// REDE
function mt_sendconfig(id: DWORD; var config: TSetupTCP): DWORD; far; stdcall; external 'pmtg.dll';
function mt_reqconfig(id: DWORD): DWORD; far; stdcall; external 'pmtg.dll';
function mt_getconfig(id: DWORD; var config: TSetupTCP): DWORD; far; stdcall; external 'pmtg.dll';
function mt_sendexconfig(id: DWORD; var configex: TExSetupTCP): DWORD; far; stdcall; external 'pmtg.dll';
function mt_reqexconfig(id: DWORD): DWORD; far; stdcall; external 'pmtg.dll';
function mt_getexconfig(id: DWORD; var configex: TExSetupTCP): DWORD; far; stdcall; external 'pmtg.dll';

// DISPLAY
function mt_backspace(id: DWORD): DWORD; far; stdcall; external 'pmtg.dll';
function mt_carret(id: DWORD): DWORD; far; stdcall; external 'pmtg.dll';
function mt_linefeed(id: DWORD): DWORD; far; stdcall; external 'pmtg.dll';
function mt_formfeed(id: DWORD): DWORD; far; stdcall; external 'pmtg.dll';
function mt_gotoxy(id: DWORD; lin: DWORD; col: DWORD): DWORD; far; stdcall; external 'pmtg.dll';
function mt_gotoxyref(id: DWORD; lin: DWORD; col: DWORD): DWORD; far; stdcall; external 'pmtg.dll';
function mt_dispstr(id: DWORD; var str: BYTE): DWORD; far; stdcall; external 'pmtg.dll';
function mt_dispch(id: DWORD; ch: BYTE): DWORD; far; stdcall; external 'pmtg.dll';
function mt_dispclrln(id: DWORD; lin: DWORD): DWORD; far; stdcall; external 'pmtg.dll';
function mt_seteditstring(id: DWORD; var str: BYTE; OnOff: DWORD; PassWord: DWORD): DWORD; far; stdcall; external 'pmtg.dll';
function mt_geteditstring(id: DWORD; var str: BYTE): DWORD; far; stdcall; external 'pmtg.dll';
function mt_reqeditstring(id: DWORD): DWORD; far; stdcall; external 'pmtg.dll';

// TECLADO
function mt_setenablekey(id: DWORD; OnOff: DWORD): DWORD; far; stdcall; external 'pmtg.dll';
function mt_getenablekey(id: DWORD): DWORD; far; stdcall; external 'pmtg.dll';
function mt_setcapslock(id: DWORD; OnOff: DWORD): DWORD; far; stdcall; external 'pmtg.dll';
function mt_getcapslock(id: DWORD): DWORD; far; stdcall; external 'pmtg.dll';
function mt_setnumlock(id: DWORD; OnOff: DWORD): DWORD; far; stdcall; external 'pmtg.dll';
function mt_getnumlock(id: DWORD): DWORD; far; stdcall; external 'pmtg.dll';
function mt_reset(id: DWORD): DWORD; far; stdcall; external 'pmtg.dll';
function mt_setbeep(id: DWORD; OnOff: DWORD): DWORD; far; stdcall; external 'pmtg.dll';
function mt_setbeepkey(id: DWORD; OnOff: DWORD): DWORD; far; stdcall; external 'pmtg.dll';
function mt_getkey(id: DWORD; var buf: BYTE): DWORD; far; stdcall; external 'pmtg.dll';
function mt_programkbd(id: DWORD; var codigo: BYTE): DWORD; far; stdcall; external 'pmtg.dll';

// SERIAL
function mt_setenableserial(id: DWORD; COM: BYTE; OnOff: DWORD): DWORD; far; stdcall; external 'pmtg.dll';
function mt_getenableserial(id: DWORD; COM: BYTE): DWORD; far; stdcall; external 'pmtg.dll';
function mt_sendbinserial(id: DWORD; COM: BYTE; var bin: BYTE; tam: BYTE): DWORD; far; stdcall; external 'pmtg.dll';
function mt_sendconfigserial(id: DWORD; var config: ARG_COM_SETUPSERIAL): DWORD; far; stdcall; external 'pmtg.dll';
function mt_reqconfigserial(id: DWORD; COM: BYTE): DWORD; far; stdcall; external 'pmtg.dll';
function mt_getconfigserial(id: DWORD; var config: ARG_COM_SETUPSERIAL): DWORD; far; stdcall; external 'pmtg.dll';
function mt_getserial(id: DWORD; var sercom: DWORD; var buf: array of BYTE): DWORD; far; stdcall; external 'pmtg.dll';
function mt_settermserial(id: DWORD; COM: DWORD; TERM: DWORD; OnOff: DWORD): DWORD; far; stdcall; external 'pmtg.dll';

// CARTO
function mt_sendsetcard(id: DWORD; OnOff: DWORD): DWORD; far; stdcall; external 'pmtg.dll';
function mt_reqgetcard(id: DWORD): DWORD; far; stdcall; external 'pmtg.dll';
function mt_getcardbuf(id: DWORD; var cardbuf: ARG_CARD): DWORD; far; stdcall; external 'pmtg.dll';

// AUXILIAR

//********************************************************************************************************
// Funo: retorna_IP
//********************************************************************************************************
//
// Data de Criao: 20/12/2007
//
// Descrio: Transforma o ID de um terminal em um endereo IP
//
//********************************************************************************************************

function retorna_IP(id: DWORD): String;
begin
    // Recebe o id dos terminais conectados.
    tabcon := mt_connectlist;
    // Transforma o ID em um endereo vlido.
    auxIP.S_addr := tabcon.TSOCK[id];
    // Formata para um endereo de IP pontuado.
    retorna_IP := (inet_ntoa(auxIP) + ' - ' + IntToStr(id));
end;

//********************************************************************************************************
// Funo: compara
//********************************************************************************************************
//
// Data de Criao: 20/12/2007
//
// Descrio: Verifica se o usurio digitou valores vlidos ('0' at '9' e de 'A' at 'F')
//
//********************************************************************************************************

function compara(buf: String): BYTE;
begin
    if (buf = '0') OR (buf = '1') OR (buf = '2') OR (buf = '3') OR (buf = '4') OR (buf = '5') OR (buf = '6') OR (buf = '7') OR (buf = '8') OR (buf = '9') OR (buf = 'a') OR (buf = 'b') OR (buf = 'c') OR (buf = 'd') OR (buf = 'e') OR (buf = 'f') OR (buf = 'A') OR (buf = 'B') OR (buf = 'C') OR (buf = 'D') OR (buf = 'E') OR (buf = 'F') then
    begin
       compara := 1;
    end
    else
    begin
       compara := 0;
    end;
end;

//********************************************************************************************************
// Funo: converte
//********************************************************************************************************
//
// Data de Criao: 20/12/2007
//
// Descrio: Converte os nmeros de decimal para hexadecimal
//
//********************************************************************************************************

function converte(str: String): BYTE;
var
    str1: String;
    str1a: INTEGER;
    str2: String;
    str2a: INTEGER;
    soma: INTEGER;
begin
    str1 := (Copy(str, 1, 1));
    str2 := (Copy(str, 2, 1));

    str1a := 0;
    str2a := 0;

    if (str1 = '0') then
        str1a := 0
    else if (str1 = '1') then
        str1a := 16
    else if (str1 = '2') then
        str1a := 32
    else if (str1 = '3') then
        str1a := 48
    else if (str1 = '4') then
        str1a := 64
    else if (str1 = '5') then
        str1a := 80
    else if (str1 = '6') then
        str1a := 96
    else if (str1 = '7') then
        str1a := 112
    else if (str1 = '8') then
        str1a := 128
    else if (str1 = '9') then
        str1a := 144
    else if (str1 = 'a') then
        str1a := 160
    else if (str1 = 'b') then
        str1a := 176
    else if (str1 = 'c') then
        str1a := 192
    else if (str1 = 'd') then
        str1a := 208
    else if (str1 = 'e') then
        str1a := 224
    else if (str1 = 'f') then
        str1a := 240;

    if (str2 = '0') then
        str2a := 0
    else if (str2 = '1') then
        str2a := 1
    else if (str2 = '2') then
        str2a := 2
    else if (str2 = '3') then
        str2a := 3
    else if (str2 = '4') then
        str2a := 4
    else if (str2 = '5') then
        str2a := 5
    else if (str2 = '6') then
        str2a := 6
    else if (str2 = '7') then
        str2a := 7
    else if (str2 = '8') then
        str2a := 8
    else if (str2 = '9') then
        str2a := 9
    else if (str2 = 'a') then
        str2a := 10
    else if (str2 = 'A') then
        str2a := 10
    else if (str2 = 'b') then
        str2a := 11
    else if (str2 = 'B') then
        str2a := 11
    else if (str2 = 'c') then
        str2a := 12
    else if (str2 = 'C') then
        str2a := 12
    else if (str1 = 'd') then
        str2a := 13
    else if (str2 = 'D') then
        str2a := 13
    else if (str2 = 'e') then
        str2a := 14
    else if (str2 = 'E') then
        str2a := 14
    else if (str2 = 'f') then
        str2a := 15
    else if (str2 = 'F') then
        str2a := 15;

    soma := str1a + str2a;

    converte := soma;
end;

//********************************************************************************************************
// Evento: WndProc
//********************************************************************************************************
//
// Data de Criao: 13/12/2007
//
// Entrada: TMessage
//
// Sada: Void
//
// Descrio: Recebe mensagens enviadas pelo terminal e as compara com as constantes referentes a cada
//            comando
//
//********************************************************************************************************

procedure TForm1.WndProc(var Message : TMessage);
var
    config: TSetupTCP;
    configex: TExSetupTCP;
    configserial: ARG_COM_SETUPSERIAL;
    configcard: ARG_CARD;
    buf: array [0..255] of BYTE;
    str: String;
    porta: DWORD;
    i: Integer;
begin
    if (Message.Msg = MsgReceiveData) then
    begin

    // ShowMessage(IntToStr(Message.WParam));

        // IDvLive
        if (Message.WParam = IDvLive) then
        begin
            // Escreve na lista de logs
            ListReceive.Items.Add('IDvLive - ' + retorna_IP(Message.LParamLo));
        end

        // IDvGetSetupTCP
        else if (Message.WParam = IDvGetSetupTCP) then
        begin
            // Recebe os dados enviados pelo terminal
            mt_getconfig(Message.LParamLo, config);

            // Cada edit recebe sua respctiva configurao de rede
            edtClienteIP.Text := mt_inet_ntoa_inv(config.microT_IP);
            edtServerIP.Text := mt_inet_ntoa_inv(config.server_IP);
            edtNetMask.Text := mt_inet_ntoa_inv(config.msknet_IP);

            // Verifica se o ip dinmico est habilitado
            if config.bDHCP = 1 then
            begin
                chkDynamicIP.Checked := True
            end
            else
            begin
                chkDynamicIP.Checked := False;
            end;

            // Escreve na lista de logs
            ListReceive.Items.Add('IDvGetSetupTCP - ' + retorna_IP(Message.LParamLo));
        end

        // IDvGetExSetupTCP
        else if (Message.WParam = IDvGetExSetupTCP) then
        begin
            // Recebe os dados enviados pelo terminal
            mt_getexconfig(Message.LParamLo, configex);

            // Cada edit recebe sua respctiva configurao de rede
            edtGateWay.Text := mt_inet_ntoa_inv(configex.gateway);
            edtNameServer.Text := mt_inet_ntoa_inv(configex.nameserver);
            edtTCName.Text := PChar(@configex.myname);
            // Escreve na lista de logs
            ListReceive.Items.Add('IDvExGetSetupTCP - ' + retorna_IP(Message.LParamLo));
        end

        // IDvBackSpace
        else if (Message.WParam = IDvBackSpace) then
        begin
            // Escreve na lista de logs
            ListReceive.Items.Add('IDvBackSpace - ' + retorna_IP(Message.LParamLo));
        end

        // IDvCarRet
        else if (Message.WParam = IDvCarRet) then
        begin
            // Escreve na lista de logs
            ListReceive.Items.Add('IDvCarRet - ' + retorna_IP(Message.LParamLo));
        end

        // IDvFormFeed
        else if (Message.WParam = IDvFormFeed) then
        begin
            // Escreve na lista de logs
            ListReceive.Items.Add('IDvFormFeed - ' + retorna_IP(Message.LParamLo));
        end

        // IDvLineFeed
        else if (Message.WParam = IDvLineFeed) then
        begin
            // Escreve na lista de logs
            ListReceive.Items.Add('IDvLineFeed - ' + retorna_IP(Message.LParamLo));
        end

        // IDvGoToXY
        else if (Message.WParam = IDvGoToXY) then
        begin
            // Escreve na lista de logs
            ListReceive.Items.Add('IDvGoToXY - Linha: ' + edtGoToXY1.Text + ' / Cloluna: ' + edtGoToXY2.Text + ' - ' + retorna_IP(Message.LParamLo));
        end

        // IDvGoToXYRef
        else if (Message.WParam = IDvGoToXYRef) then
        begin
            // Escreve na lista de logs
            ListReceive.Items.Add('IDvGoToXYRef - Linha: ' + edtGoToXYRef1.Text + ' / Cloluna: ' + edtGoToXYRef2.Text + ' - ' + retorna_IP(Message.LParamLo));
        end

        // IDvDispStr
        else if (Message.WParam = IDvDispStr) then
        begin
            // Escreve na lista de logs
            ListReceive.Items.Add('IDvDispStr - ' + edtDispStr.Text + ' - ' + retorna_IP(Message.LParamLo));
        end

        // IDvDispClrLn
        else if (Message.WParam = IDvDispClrLn) then
        begin
            // Escreve na lista de logs
            ListReceive.Items.Add('IDvDispClrLn - ' + edtDispClrLn.Text + ' - ' + retorna_IP(Message.LParamLo));
        end

        // IDvSetEditString
        else if (Message.WParam = IDvSetEditString) then
        begin
            // Escreve na lista de logs
            ListReceive.Items.Add('IDvSetEditString - ' + edtString.Text + ' - ' + retorna_IP(Message.LParamLo));
        end

        // IDbGetEditString
        else if (Message.WParam = IDbGetEditString) then
        begin
            // Busca o endereo IP do ID correspondente
            retorna_IP(Message.LParamLo);
            // Escreve na lista de logs
            ListReceive.Items.Add('IDbGetEditString - ' + IntToStr(Message.LParamHi) + ' - ' + retorna_IP(Message.LParamLo));
        end

        // IDbReadEditString
        else if (Message.WParam = IDbReadEditString) then
        begin
            // Recebe os dados enviados pelo terminal
            mt_geteditstring(Message.LParamLo, buf[0]);
            // Converte BYTE (varivel buf) para String (varivel str)
            str := PChar(@buf);
            // Busca o endereo IP do ID correspondente
            retorna_IP(Message.LParamLo);
            // Escreve na lista de logs
            ListReceive.Items.Add('IDbReadEditString - ' + str + ' - ' + retorna_IP(Message.LParamLo));
        end

        // IDcGetCharTerm
        else if (Message.WParam = IDcGetCharTerm) then
        begin
            // Recebe uma tecla do terminal
            mt_getkey(Message.LParamLo, buf[0]);
            if (chkEco.Checked = True) then
            begin
                mt_dispch(Message.LParamLo,buf[0]);
            end;
            // Busca o endereo IP do ID correspondente
            retorna_IP(Message.LParamLo);
            // Escreve na lista de logs
            ListReceive.Items.Add('IDcGetCharTerm - ' + PChar(@buf) + ' - ' + retorna_IP(Message.LParamLo));
        end

        // IDvSetEnableKey
        else if (Message.WParam = IDvSetEnableKey) then
        begin
            // Escreve na lista de logs
            ListReceive.Items.Add('IDvSetEnableKey - ' + retorna_IP(Message.LParamLo));
        end

        // IDbGetEnableKey
        else if (Message.WParam = IDbGetEnableKey) then
        begin
            // Busca o endereo IP do ID correspondente
            retorna_IP(Message.LParamLo);
            // Escreve na lista de logs
            ListReceive.Items.Add('IDbGetEnableKey - ' + IntToStr(Message.LParamHi) + ' - ' + retorna_IP(Message.LParamLo));
        end

        // IDvSetCapsLock
        else if (Message.WParam = IDvSetCapsLock) then
        begin
            // Escreve na lista de logs
            ListReceive.Items.Add('IDvSetCapsLock - ' + retorna_IP(Message.LParamLo));
        end

        // IDbGetCapsLock
        else if (Message.WParam = IDbGetCapsLock) then
        begin
            // Busca o endereo IP do ID correspondente
            retorna_IP(Message.LParamLo);
            // Escreve na lista de logs
            ListReceive.Items.Add('IDbGetCapsLock - ' + IntToStr(Message.LParamHi) + ' - ' + retorna_IP(Message.LParamLo));
        end

        // IDvSetNumLock
        else if (Message.WParam = IDvSetNumLock) then
        begin
            // Escreve na lista de logs
            ListReceive.Items.Add('IDvSetNumLock - ' + retorna_IP(Message.LParamLo));
        end

        // IDbGetNumLock
        else if (Message.WParam = IDbGetNumLock) then
        begin
            // Busca o endereo IP do ID correspondente
            retorna_IP(Message.LParamLo);
            // Escreve na lista de logs
            ListReceive.Items.Add('IDbGetNumLock - ' + IntToStr(Message.LParamHi) + ' - ' + retorna_IP(Message.LParamLo));
        end

        // IDvReset
        else if (Message.WParam = IDvReset) then
        begin
            // Escreve na lista de logs
            ListReceive.Items.Add('IDvReset - ' + retorna_IP(Message.LParamLo));
        end

        // IDvSetBeep
        else if (Message.WParam = IDvSetBeep) then
        begin
            // Escreve na lista de logs
            ListReceive.Items.Add('IDvSetBeep - ' + retorna_IP(Message.LParamLo));
        end

        // IDvSetBeepKey
        else if (Message.WParam = IDvSetBeepKey) then
        begin
            // Escreve na lista de logs
            ListReceive.Items.Add('IDvSetBeepKey - ' + retorna_IP(Message.LParamLo));
        end

        // IDvSetEnableSerial
        else if (Message.WParam = IDvSetEnableSerial) then
        begin
            // Escreve na lista de logs
            ListReceive.Items.Add('IDvSetEnableSerial - ' + retorna_IP(Message.LParamLo));
        end

        // IDbGetEnableSerial
        else if (Message.WParam = IDbGetEnableSerial) then
        begin
            // Busca o endereo IP do ID correspondente
            retorna_IP(Message.LParamLo);
            // Escreve na lista de logs
            ListReceive.Items.Add('IDbGetEnableSerial - ' + IntToStr(Message.LParamHi) + ' - ' + retorna_IP(Message.LParamLo));
        end

        // IDvGetSetupSerial
        else if (Message.WParam = IDvGetSetupSerial) then
        begin
            // Recebe as configuraes enviadas pelo terminal
            mt_getconfigserial(Message.LParamLo, configserial);

            // Cada combo recebe sua respctiva configurao de serial
            cbBaud.Text := IntToStr(configserial.Setup.baud);
            cbBits.Text := IntToStr(configserial.Setup.bits);

            if configserial.Setup.parity = 0 then
                cbParidade.Text := 'Nenhum'
            else if configserial.Setup.parity = 1 then
                cbParidade.Text := 'Impar'
            else if configserial.Setup.parity = 2 then
                cbParidade.Text := 'Par'
            else if configserial.Setup.parity = 3 then
                cbParidade.Text := 'Marca'
            else if configserial.Setup.parity = 4 then
                cbParidade.Text := 'Espao';

            cbStop.Text := IntToStr(configserial.Setup.stops);

            if configserial.Setup.handshaking = 0 then
                cbHand.Text := 'Nenhum'
            else if configserial.Setup.handshaking = 1 then
                cbHand.Text := 'CTS / RTS';

            // Escreve na lista de logs
            ListReceive.Items.Add('IDvGetSetupSerial - ' + retorna_IP(Message.LParamLo));
        end

        // IDbGetBinSerial
        else if (Message.WParam = IDbGetBinSerial) then
        begin
            porta := cbPorta.ItemIndex;
            mt_getserial(Message.LParamLo,porta,buf[0]);

            // Escreve na lista de logs
            ListReceive.Items.Add('IDbGetBinSerial - ' + PChar(@buf) + ' - ' + retorna_IP(Message.LParamLo));
        end

        // IDvSetCard
        else if (Message.WParam = IDvSetCard) then
        begin
            // Escreve na lista de logs
            ListReceive.Items.Add('IDvSetCard - ' + retorna_IP(Message.LParamLo));
        end

        // IDbGetCard
        else if (Message.WParam = IDbGetCard) then
        begin
            // Busca o endereo IP do ID correspondente
            retorna_IP(Message.LParamLo);
            // Escreve na lista de logs
            ListReceive.Items.Add('IDbGetCard - ' + IntToStr(Message.LParamHi) + ' - ' + retorna_IP(Message.LParamLo));
        end

        // IDbReadBuffCard
        else if (Message.WParam = IDbReadBuffCard) then
        begin
            // Recebe os dados enviados pelo terminal
            mt_getcardbuf(Message.LParamLo,configcard);
            // Converte BYTE (varivel buf) para String (varivel str)
            str := PChar(@configcard.card);
            edtCartao.Text := str;
            // Escreve na lista de logs
            ListReceive.Items.Add('IDbReadBuffCard - ' + str + ' - ' + retorna_IP(Message.LParamLo));
        end;

    end;

    inherited WndProc(Message);

end;

//********************************************************************************************************
// Evento: Timer1Timer
//********************************************************************************************************
//
// Data de Criao: 13/12/2007
//
// Descrio: Atualiza lista de terminais conectados
//
//            mt_connectlist -> Esta funo retorna uma varivel do tipo TABSOCK com todos
//            os id's dos terminais conectados, um em cada ndice da varivel TSOCK
//
//********************************************************************************************************

procedure TForm1.Timer1Timer(Sender: TObject);
var
    i: Integer;
    terminal: Integer;
begin
    // Recebe o index de um item selecionado na lista de terminais conectados.
    if (ListBox1.Items.Text <> '') then
    begin
        terminal := ListBox1.ItemIndex;
    end;

    // Limpa a Lista de terminais antes de atualiza-la.
    ListBox1.Clear;

    // Recebe o id dos terminais conectados.
    tabcon := mt_connectlist;

    i := 0;
    while (i < 255) do
    begin
        if (tabcon.TSOCK[i] <> 0) then
        begin
            // Transforma o ID em um endereo vlido.
            auxIP.S_addr := tabcon.TSOCK[i];
            // Formata para um endereo de IP pontuado e exibe na lista de conectados.
            ListBox1.Items.Add(inet_ntoa(auxIP)  + ' - ' + IntToStr(i));
            // Seleciona o primeiro item da lista de terminais conectados.
            ListBox1.ItemIndex := 0;
        end;
        i := i + 1;
    end;

    // Seleciona o terminal que estava selecionado anteriormente na lista de terminais conectados.
    if (ListBox1.Items.Text <> '') then
    begin
        ListBox1.ItemIndex := terminal;
    end;

    // Envia vLive para todos os terminais conctados.
    i := 0;
    while (i < 255) do
    begin
        if (tabcon.TSOCK[i] <> 0) then
        begin
            mt_sendlive(i);
            Sleep(1);
        end;
        i := i + 1;
    end;
end;

//********************************************************************************************************
// Evento: FormCreate
//********************************************************************************************************
//
// Data de Criao: 13/12/2007
//
// Entrada: TObject
//
// Sada: Void
//
// Descrio: Inicializa Servidor e DLL
//
//            mt_startserver(a, b, c) -> Esta  a primeira funo que deve ser chamada. Se tiver sucesso
//            na sua chamada, os terminais j conectaro ao servidor.
//            a -> Handle do Form para onde a DLL ir mandar as mensagens para troca de dados.
//            b -> Valor da mensagem que a DLL enviar quando um terminal conectar / desconectar.
//            c -> Valor da mensagem que a DLL enviar quando terminal enviar dados.
//            Retorna: 1 se Servidor inicializado com sucesso, 0 se houve algum erro.
//
//********************************************************************************************************

procedure TForm1.FormCreate(Sender: TObject);
begin

    MsgReceiveData := 0;
    // CONNECT_MSG := 2;

    // Inicializa DLL e servidor
    if mt_startserver(Form1.Handle, 0, MsgReceiveData) = 1 then
    begin
        // Informa no ListReceive que o servidor foi inicializado com sucesso
        ListReceive.Items.Add('<<<Servidor Inicializado Corretamente>>>');

        //Habilita Timer para atualizao de terminais conectados
        Timer1.Enabled := True;
    end
    else
    begin
        // Informa no ListReceive que o servidor no foi inicializado com sucesso
        ListReceive.Items.Add('<<<Falha na Inicializao do Servidor>>>');
    end;
end;

//********************************************************************************************************
// Evento: FormDestroy
//********************************************************************************************************
//
// Data de Criao: 13/12/2007
//
// Descrio: Aps chamar esta funo, a DLL libera a memria armazenada, desconecta todos os terminais
//            e para de aceitar novas conexes.
//
//********************************************************************************************************

procedure TForm1.FormDestroy(Sender: TObject);
begin
    mt_finishserver;
end;

//********************************************************************************************************
// Evento: btnAtualizarClick
//********************************************************************************************************
//
// Data de Criao: 13/12/2007
//
// Descrio: Atualiza lista de terminais conectados
//
//********************************************************************************************************

procedure TForm1.btnAtualizarClick(Sender: TObject);
begin
    Timer1Timer(Sender);
end;

//********************************************************************************************************
// Evento: btnRestartClick
//********************************************************************************************************
//
// Data de Criao: 13/12/2007
//
// Descrio: Envia o comando restart para o terminal selecionado da lista
//
//********************************************************************************************************

procedure TForm1.btnRestartClick(Sender: TObject);
begin
    // Verifica se h algum terminal selecionado
    if (ListBox1.ItemIndex = -1) then
    begin
        Application.MessageBox('Selecione um terminal.','IP do Terminal',48)
    end
    else
    begin
        // Envia o comando restart para o terminail
        if mt_restart(id_selecionado) < 1 then
        begin
            Application.MessageBox('Erro enviando comando.','ERRO',16)
        end
        else
        begin
            // Escreve na lista de logs
            ListReceive.Items.Add('IDvRestart - ' + ListBox1.Items.Strings[ListBox1.ItemIndex]);
        end;
    end;
end;

//********************************************************************************************************
// Evento: btnFTPModeClick
//********************************************************************************************************
//
// Data de Criao: 13/12/2007
//
// Descrio: Envia o comando entrar em modo FTP para o terminal selecionado na lista
//
//********************************************************************************************************

procedure TForm1.btnFTPModeClick(Sender: TObject);
begin
    // Verifica se h algum terminal selecionado
    if (ListBox1.ItemIndex = -1) then
    begin
        Application.MessageBox('Selecione um terminal.','IP do Terminal',48)
    end
    else
    begin
        // Envia o comando para entrar em modo FTP
        if mt_ftpmode(id_selecionado) < 1 then
        begin
            Application.MessageBox('Erro enviando comando.','ERRO',16);
        end
        else
        begin
            // Escreve na lista de logs
            ListReceive.Items.Add('IDvModeFTP - ' + ListBox1.Items.Strings[ListBox1.ItemIndex]);
        end;
    end;
end;

//********************************************************************************************************
// Evento: btnClearClick
//********************************************************************************************************
//
// Data de Criao: 13/12/2007
//
// Descrio: Limpa a lista de logs
//
//********************************************************************************************************

procedure TForm1.btnClearClick(Sender: TObject);
begin
    ListReceive.Clear;
end;

//********************************************************************************************************
// Evento: btnReceberConfNetClick
//********************************************************************************************************
//
// Data de Criao: 13/12/2007
//
// Descrio: Requisita configurao da EtherNet do terminal
//
//********************************************************************************************************

procedure TForm1.btnReceberConfNetClick(Sender: TObject);
begin
    // Verifica se h algum terminal selecionado
    if (ListBox1.ItemIndex = -1) then
    begin
        Application.MessageBox('Selecione um terminal.','Rede',48)
    end
    else
    begin
        // Requisita configurao do terminal
        if mt_reqconfig(id_selecionado) < 1 then
        begin
            Application.MessageBox('Erro enviando comando.','ERRO',16);
        end;
    end;
end;

//********************************************************************************************************
// Evento: btnEnviarConfNetClick
//********************************************************************************************************
//
// Data de Criao: 13/12/2007
//
// Descrio: Envia configurao da EtherNet para o terminal
//
//********************************************************************************************************

procedure TForm1.btnEnviarConfNetClick(Sender: TObject);
var
    config: TSetupTCP;
begin
    // Verifica se h algum terminal selecionado
    if (ListBox1.ItemIndex = -1) OR (edtClienteIP.Text = '') OR (edtServerIP.Text = '') OR (edtNetMask.Text = '')then
    begin
        Application.MessageBox('Selecione um terminal ou preencha corretamente os campos.','Rede',48)
    end
    else
    begin
        // Cada campo recebe sua respctiva configurao de rede
        config.microT_IP := mt_inet_addr_inv(edtClienteIP.Text);
        config.server_IP := mt_inet_addr_inv(edtServerIP.Text);
        config.msknet_IP := mt_inet_addr_inv(edtNetMask.Text);

        if chkDynamicIP.Checked = True then
        begin
            config.bDHCP := 1
        end
        else
        begin
            config.bDHCP := 0
        end;

        // Envia configurao para o terminal
        if mt_sendconfig(id_selecionado, config) < 1 then
        begin
            Application.MessageBox('Erro enviando comando.','ERRO',16)
        end
        else
        begin
            // Escreve na lista de logs
            ListReceive.Items.Add('IDvSetSetupTCP - ' + ListBox1.Items.Strings[ListBox1.ItemIndex]);
            Sleep(50);
            mt_restart(id_selecionado);
        end;
    end;
end;

//********************************************************************************************************
// Evento: btnReceberConfExNetClick
//********************************************************************************************************
//
// Data de Criao: 13/12/2007
//
// Descrio: Requisita configurao da ExEtherNet para o terminal
//
//********************************************************************************************************

procedure TForm1.btnReceberConfExNetClick(Sender: TObject);
begin
    // Verifica se h algum terminal selecionado
    if (ListBox1.ItemIndex = -1) then
    begin
        Application.MessageBox('Selecione um terminal.','Rede', 48)
    end
    else
    begin
        // Requisita configurao do terminal
        if mt_reqexconfig(id_selecionado) < 1 then
        begin
            Application.MessageBox('Erro enviando comando.','ERRO',16);
        end;
    end;
end;

//********************************************************************************************************
// Evento: btnEnviarConfExNetClick
//********************************************************************************************************
//
// Data de Criao: 13/12/2007
//
// Descrio: Envia configurao da ExEtherNet para o terminal
//
//********************************************************************************************************

procedure TForm1.btnEnviarConfExNetClick(Sender: TObject);
var
    configex: TExSetupTCP;
    n: DWORD;
begin
    // Verifica se h algum terminal selecionado
    if (ListBox1.ItemIndex = -1) OR (edtGateWay.Text = '') OR (edtNameServer.Text = '') OR (edtTCName.Text = '')then
    begin
        Application.MessageBox('Selecione um terminal ou preencha corretamente os campos.','Rede',48)
    end
    else
    begin
        // Cada campo recebe sua respctiva configurao de rede
        configex.gateway := mt_inet_addr_inv(edtGateWay.Text);
        configex.nameserver := mt_inet_addr_inv(edtNameServer.Text);

        For n := 1 To Length(edtTCName.Text) do
        begin
            configex.myname[n] := byte(edtTCName.Text[n]);
        end;

        configex.myname[n] := 0;

        // Envia configurao para o terminal
        if mt_sendexconfig(id_selecionado, configex) < 1 then
        begin
            Application.MessageBox('Erro enviando comando.','ERRO',16)
        end
        else
        begin
            // Escreve na lista de logs
            ListReceive.Items.Add('IDvSetExSetupTCP - ' + ListBox1.Items.Strings[ListBox1.ItemIndex]);
            Sleep(50);
            mt_restart(id_selecionado);
        end;
    end;
end;

//********************************************************************************************************
// Evento: btnBackSpaceClick
//********************************************************************************************************
//
// Data de Criao: 14/12/2007
//
// Descrio: Apaga o caracter a esquerda do cursor
//
//********************************************************************************************************

procedure TForm1.btnBackSpaceClick(Sender: TObject);
begin
    // Verifica se h algum terminal selecionado
    if (ListBox1.ItemIndex = -1) then
    begin
        Application.MessageBox('Selecione um terminal.','Display',48)
    end
    else
    begin
        // Envia o comando de CarRet para o terminal
        if mt_backspace(id_selecionado) < 1 then
        begin
            Application.MessageBox('Erro enviando comando.','ERRO',16);
        end;
    end;
end;

//********************************************************************************************************
// Evento: btnCarRetClick
//********************************************************************************************************
//
// Data de Criao: 14/12/2007
//
// Descrio: Retorna na primeira linha e coluna (1, 1)
//
//********************************************************************************************************

procedure TForm1.btnCarRetClick(Sender: TObject);
begin
    // Verifica se h algum terminal selecionado
    if (ListBox1.ItemIndex = -1) then
    begin
        Application.MessageBox('Selecione um terminal.','Display',48)
    end
    else
    begin
        // Envia o comando de CarRet para o terminal
        if mt_carret(id_selecionado) < 1 then
        begin
            Application.MessageBox('Erro enviando comando.','ERRO',16);
        end;
    end;
end;

//********************************************************************************************************
// Evento: btnFormFeedClick
//********************************************************************************************************
//
// Data de Criao: 14/12/2007
//
// Descrio: Apaga todos caracteres do display
//
//********************************************************************************************************

procedure TForm1.btnFormFeedClick(Sender: TObject);
begin
    // Verifica se h algum terminal selecionado
    if (ListBox1.ItemIndex = -1) then
    begin
        Application.MessageBox('Selecione um terminal.','Display',48)
    end
    else
    begin
        // Envia o comando de FormFeed para o terminal
        if mt_formfeed(id_selecionado) < 1 then
        begin
            Application.MessageBox('Erro enviando comando.','ERRO',16);
        end;
    end;
end;

//********************************************************************************************************
// Evento: btnLineFeedClick
//********************************************************************************************************
//
// Data de Criao: 14/12/2007
//
// Descrio: Pula para a prxima linha
//
//********************************************************************************************************

procedure TForm1.btnLineFeedClick(Sender: TObject);
begin
    // Verifica se h algum terminal selecionado
    if (ListBox1.ItemIndex = -1) then
    begin
        Application.MessageBox('Selecione um terminal.','Display',48)
    end
    else
    begin
        // Envia o comando de LineFeed para o terminal
        if mt_linefeed(id_selecionado) < 1 then
        begin
            Application.MessageBox('Erro enviando comando.','ERRO',16);
        end;
    end;
end;

//********************************************************************************************************
// Evento: btnGoToXYClick
//********************************************************************************************************
//
// Data de Criao: 14/12/2007
//
// Descrio: Posiciona o cursor na posio (linha, coluna) X, Y do display
//
//********************************************************************************************************

procedure TForm1.btnGoToXYClick(Sender: TObject);
var
    lin: DWORD;
    col: DWORD;
begin
    Try
    lin := StrToInt(edtGoToXY1.Text);
    col := StrToInt(edtGoToXY2.Text);

    // Verifica se h algum terminal selecionado
    if (ListBox1.ItemIndex = -1) then
    begin
        Application.MessageBox('Selecione um terminal.','Display',48);
    end
    else
    begin
        // Envia o comando de GoToXY para o terminal
        if mt_gotoxy(id_selecionado, lin, col) < 1 then
        begin
            Application.MessageBox('Erro enviando comando.','ERRO',16);
        end;
    end;
    Except
        Application.MessageBox('Preencha corretamento os campos.','Display',48);
    end;
end;

//********************************************************************************************************
// Evento: btnGoToXYRefClick
//********************************************************************************************************
//
// Data de Criao: 14/12/2007
//
// Descrio: Posiciona o cursor na posio (linha, coluan) X, Y do display conforme a referncia anterior
// do cursor
//
//********************************************************************************************************

procedure TForm1.btnGoToXYRefClick(Sender: TObject);
var
    lin: DWORD;
    col: DWORD;
begin
    Try
    lin := StrToInt(edtGoToXYRef1.Text);
    col := StrToInt(edtGoToXYRef2.Text);

    // Verifica se h algum terminal selecionado
    if (ListBox1.ItemIndex = -1) then
    begin
        Application.MessageBox('Selecione um terminal.','Display',48)
    end
    else
    begin
        // Envia o comando de GoToXYRef para o terminal
        if mt_gotoxyref(id_selecionado, lin, col) < 1 then
        begin
            Application.MessageBox('Erro enviando comando.','ERRO',16);
        end;
    end;
    Except
        Application.MessageBox('Preencha corretamento os campos.','Display',48);
    end;
end;

//********************************************************************************************************
// Evento: btnDispStrClick
//********************************************************************************************************
//
// Data de Criao: 14/12/2007
//
// Descrio: Envia uma string para o display
//
//********************************************************************************************************

procedure TForm1.btnDispStrClick(Sender: TObject);
var
    buf: array [0..255] of BYTE;
begin
    Try
    // Verifica se h algum terminal selecionado
    if (ListBox1.ItemIndex = -1) then
    begin
        Application.MessageBox('Selecione um terminal.','Display',48)
    end
    else
    begin
        StrPCopy(@buf,edtDispStr.Text);

        // Envia o comando de DisplayString para o terminal
        if mt_dispstr(id_selecionado, buf[0]) < 1 then
        begin
            Application.MessageBox('Erro enviando comando.','ERRO',16);
        end;
    end;
    Except
        Application.MessageBox('Preencha corretamento os campos.','Display',48);
    end;
end;

//********************************************************************************************************
// Evento: btnDispCharClick
//********************************************************************************************************
//
// Data de Criao: 14/12/2007
//
// Descrio: Envia um caracter para o display
//
//********************************************************************************************************

procedure TForm1.btnDispCharClick(Sender: TObject);
var
    buf: array [0..1] of BYTE;
begin
    Try
    // Verifica se h algum terminal selecionado
    if (ListBox1.ItemIndex = -1) then
    begin
        Application.MessageBox('Selecione um terminal.','Display',48)
    end
    else
    begin
        StrPCopy(@buf,edtDispChar.Text);
        // Envia o comando de DisplayCharacter para o terminal
        if mt_dispch(id_selecionado, buf[0]) < 1 then
        begin
            Application.MessageBox('Erro enviando comando.','ERRO',16);
        end
        else
        begin
            ListReceive.Items.Add('IDvDispCh - ' + edtDispChar.Text + ' - ' + ListBox1.Items.Strings[ListBox1.ItemIndex]);
        end;
    end;
    Except
        Application.MessageBox('Preencha corretamento os campos.','Display',48);
    end;
end;

//********************************************************************************************************
// Evento: btnDispClrLnClick
//********************************************************************************************************
//
// Data de Criao: 14/12/2007
//
// Descrio: Limpa a linha indicada atravs da edit
//
//********************************************************************************************************

procedure TForm1.btnDispClrLnClick(Sender: TObject);
begin
    Try
    // Verifica se h algum terminal selecionado
    if (ListBox1.ItemIndex = -1) then
    begin
        Application.MessageBox('Selecione um terminal.','Display',48)
    end
    else
    begin
        // Envia o comando de DisplayClearLine para o terminal
        if mt_dispclrln(id_selecionado, StrToInt(edtDispClrLn.Text)) < 1 then
        begin
            Application.MessageBox('Erro enviando comando.','ERRO',16);
        end;
    end;
    Except
        Application.MessageBox('Preencha corretamento os campos.','Display',48);
    end;
end;

//********************************************************************************************************
// Evento: btnHabilitaStringClick
//********************************************************************************************************
//
// Data de Criao: 14/12/2007
//
// Descrio: Habilita a edio de string no display
//            Terceira parmetro: (1) ativa e (0) desativa a edio de string
//            Quatro parmetro: (1) habilita e (0) desabilita o modo de senha
//
//********************************************************************************************************

procedure TForm1.btnHabilitaStringClick(Sender: TObject);
var
    buf : array [0..255] of BYTE;
    estado: DWORD;
begin
    // Verifica se h algum terminal selecionado
    if (ListBox1.ItemIndex = -1) then
    begin
        Application.MessageBox('Selecione um terminal.','Display',48)
    end
    else
    begin
        StrPCopy(@buf,edtString.Text);
        if (chkPassWord.Checked = True) then
        begin
            estado := 1
        end
        else
        begin
            estado := 0;
        end;
        // Envia o comando de EditString para o terminal
        if mt_seteditstring(id_selecionado,buf[0],1,estado) < 1 then
        begin
            Application.MessageBox('Erro enviando comando.','ERRO',16);
        end;
    end;
end;

//********************************************************************************************************
// Evento: btnDesabilitaStringClick
//********************************************************************************************************
//
// Data de Criao: 14/12/2007
//
// Descrio: Desabilita a edio de string no dislay
//            Terceira parmetro: (1) ativa e (0) desativa a edio de string
//            Quatro parmetro: (1) habilita e (0) desabilita o modo de senha
//
//********************************************************************************************************

procedure TForm1.btnDesabilitaStringClick(Sender: TObject);
var
    buf : array [0..255] of BYTE;
    estado: DWORD;
begin
    // Verifica se h algum terminal selecionado
    if (ListBox1.ItemIndex = -1) then
    begin
        Application.MessageBox('Selecione um terminal.','Display',48)
    end
    else
    begin
        StrPCopy(@buf,edtString.Text);
        if (chkPassWord.Checked = True) then
        begin
            estado := 1
        end
        else
        begin
            estado := 0;
        end;
        // Envia o comando de EditString para o terminal
        if mt_seteditstring(id_selecionado,buf[0],0,estado) < 1 then
        begin
            Application.MessageBox('Erro enviando comando.','ERRO',16);
        end;
    end;
end;

//********************************************************************************************************
// Evento: btnStatusClick
//********************************************************************************************************
//
// Data de Criao: 17/12/2007
//
// Descrio: Requisita o estado de edio de string no display
//
//********************************************************************************************************

procedure TForm1.btnStatusClick(Sender: TObject);
begin
    // Verifica se h algum terminal selecionado
    if (ListBox1.ItemIndex = -1) then
    begin
        Application.MessageBox('Selecione um terminal.','Display',48)
    end
    else
    begin
        // Requisita o estado do EditString do terminal
        if mt_reqeditstring(id_selecionado) < 1 then
        begin
            Application.MessageBox('Erro enviando comando.','ERRO',16);
        end;
    end;
end;

//********************************************************************************************************
// Evento: rdAtivado1Click
//********************************************************************************************************
//
// Data de Criao: 17/12/2007
//
// Descrio: Envia o comando para habilitar as teclas do terminal
//            Segundo parmetro: (1) ativa e (0) desativa as teclas do terminal
//
//********************************************************************************************************

procedure TForm1.rdAtivado1Click(Sender: TObject);
begin
    // Verifica se h algum terminal selecionado
    if (ListBox1.ItemIndex = -1) then
    begin
        Application.MessageBox('Selecione um terminal.','Teclado',48);
        rdAtivado1.Checked := False;
        rdDesativado1.Checked := False;
    end
    else
    begin
        // Envia o comando de EnableKey para o terminal
        if mt_setenablekey(id_selecionado,1) < 1 then
        begin
            Application.MessageBox('Erro enviando comando.','ERRO',16);
        end;
    end;
end;

//********************************************************************************************************
// Evento: rdDesativado1Click
//********************************************************************************************************
//
// Data de Criao: 17/12/2007
//
// Descrio: Envia o comando para desabilitar as teclas do terminal
//            Segundo parmetro: (1) ativa e (0) desativa as teclas do terminal
//
//********************************************************************************************************

procedure TForm1.rdDesativado1Click(Sender: TObject);
begin
    // Verifica se h algum terminal selecionado
    if (ListBox1.ItemIndex = -1) then
    begin
        Application.MessageBox('Selecione um terminal.','Teclado',48);
        rdAtivado1.Checked := False;
        rdDesativado1.Checked := False;
    end
    else
    begin
        // Envia o comando de EnableKey para o terminal
        if mt_setenablekey(id_selecionado,0) < 1 then
        begin
            Application.MessageBox('Erro enviando comando.','ERRO',16);
        end;
    end;
end;

//********************************************************************************************************
// Evento: btnGetEnableKeyClick
//********************************************************************************************************
//
// Data de Criao: 17/12/2007
//
// Descrio: Requisita o estado da habilitao de teclas no terminal
//
//********************************************************************************************************

procedure TForm1.btnGetEnableKeyClick(Sender: TObject);
begin
    // Verifica se h algum terminal selecionado
    if (ListBox1.ItemIndex = -1) then
    begin
        Application.MessageBox('Selecione um terminal.','Teclado',48)
    end
    else
    begin
        // Requisita o estado do EnableKey do terminal
        if mt_getenablekey(id_selecionado) < 1 then
        begin
            Application.MessageBox('Erro enviando comando.','ERRO',16);
        end;
    end;
end;

//********************************************************************************************************
// Evento: rdAtivado2Click
//********************************************************************************************************
//
// Data de Criao: 17/12/2007
//
// Descrio: Envia o comando para habilitar o caps lock do terminal
//            Segundo parmetro: (1) ativa e (0) desativa o caps lock do terminal
//
//********************************************************************************************************

procedure TForm1.rdAtivado2Click(Sender: TObject);
begin
    // Verifica se h algum terminal selecionado
    if (ListBox1.ItemIndex = -1) then
    begin
        Application.MessageBox('Selecione um terminal.','Teclado',48);
        rdAtivado2.Checked := False;
        rdDesativado2.Checked := False;
    end
    else
    begin
        // Envia o comando de CapsLock para o terminal
        if mt_setcapslock(id_selecionado,1) < 1 then
        begin
            Application.MessageBox('Erro enviando comando.','ERRO',16);
        end;
    end;
end;

//********************************************************************************************************
// Evento: rdDesativado2Click
//********************************************************************************************************
//
// Data de Criao: 17/12/2007
//
// Descrio: Envia o comando para desabilitar o caps lock do terminal
//            Segundo parmetro: (1) ativa e (0) desativa o caps lock do terminal
//
//********************************************************************************************************

procedure TForm1.rdDesativado2Click(Sender: TObject);
begin
    // Verifica se h algum terminal selecionado
    if (ListBox1.ItemIndex = -1) then
    begin
        Application.MessageBox('Selecione um terminal.','Teclado',48);
        rdAtivado2.Checked := False;
        rdDesativado2.Checked := False;
    end
    else
    begin
        // Envia o comando de CapsLock para o terminal
        if mt_setcapslock(id_selecionado,0) < 1 then
        begin
            Application.MessageBox('Erro enviando comando.','ERRO',16);
        end;
    end;
end;

//********************************************************************************************************
// Evento: btnGetCapsLockClick
//********************************************************************************************************
//
// Data de Criao: 17/12/2007
//
// Descrio: Requisita o estado do caps lock no terminal
//
//********************************************************************************************************

procedure TForm1.btnGetCapsLockClick(Sender: TObject);
begin
    // Verifica se h algum terminal selecionado
    if (ListBox1.ItemIndex = -1) then
    begin
        Application.MessageBox('Selecione um terminal.','Teclado',48)
    end
    else
    begin
        // Requisita o estado do CapsLock do terminal
        if mt_getcapslock(id_selecionado) < 1 then
        begin
            Application.MessageBox('Erro enviando comando.','ERRO',16);
        end;
    end;
end;

//********************************************************************************************************
// Evento: rdAtivado3Click
//********************************************************************************************************
//
// Data de Criao: 17/12/2007
//
// Descrio: Envia o comando para habilitar o num lock do terminal
//            Segundo parmetro: (1) ativa e (0) desativa o caps lock do terminal
//
//********************************************************************************************************

procedure TForm1.rdAtivado3Click(Sender: TObject);
begin
    // Verifica se h algum terminal selecionado
    if (ListBox1.ItemIndex = -1) then
    begin
        Application.MessageBox('Selecione um terminal.','Teclado',48);
        rdAtivado3.Checked := False;
        rdDesativado3.Checked := False;
    end
    else
    begin
        // Envia o comando de NumLock para o terminal
        if mt_setnumlock(id_selecionado,1) < 1 then
        begin
            Application.MessageBox('Erro enviando comando.','ERRO',16);
        end;
    end;
end;

//********************************************************************************************************
// Evento: rdDesativado3Click
//********************************************************************************************************
//
// Data de Criao: 17/12/2007
//
// Descrio: Envia o comando para desabilitar o num lock do terminal
//            Segundo parmetro: (1) ativa e (0) desativa o caps lock do terminal
//
//********************************************************************************************************

procedure TForm1.rdDesativado3Click(Sender: TObject);
begin
    // Verifica se h algum terminal selecionado
    if (ListBox1.ItemIndex = -1) then
    begin
        Application.MessageBox('Selecione um terminal.','Teclado',48);
        rdAtivado3.Checked := False;
        rdDesativado3.Checked := False;
    end
    else
    begin
        // Envia o comando de NumLock para o terminal
        if mt_setnumlock(id_selecionado,0) < 1 then
        begin
            Application.MessageBox('Erro enviando comando.','ERRO',16);
        end;
    end;
end;

//********************************************************************************************************
// Evento: btnGetNumLockClick
//********************************************************************************************************
//
// Data de Criao: 17/12/2007
//
// Descrio: Requisita o estado do num lock no terminal
//
//********************************************************************************************************

procedure TForm1.btnGetNumLockClick(Sender: TObject);
begin
    // Verifica se h algum terminal selecionado
    if (ListBox1.ItemIndex = -1) then
    begin
        Application.MessageBox('Selecione um terminal.','Teclado',48)
    end
    else
    begin
        // Requisita o estado do NumLock do terminal
        if mt_getnumlock(id_selecionado) < 1 then
        begin
            Application.MessageBox('Erro enviando comando.','ERRO',16);
        end;
    end;
end;

//********************************************************************************************************
// Evento: btnResetClick
//********************************************************************************************************
//
// Data de Criao: 17/12/2007
//
// Descrio: Envia o comando de Reset para o terminal
//
//********************************************************************************************************

procedure TForm1.btnResetClick(Sender: TObject);
begin
    // Verifica se h algum terminal selecionado
    if (ListBox1.ItemIndex = -1) then
    begin
        Application.MessageBox('Selecione um terminal.','Teclado',48)
    end
    else
    begin
        // Envia o comando para resetar as configuraes do terminal
        if mt_reset(id_selecionado) < 1 then
        begin
            Application.MessageBox('Erro enviando comando.','ERRO',16);
        end;
    end;
end;

//********************************************************************************************************
// Evento: btnBeepOnClick
//********************************************************************************************************
//
// Data de Criao: 17/12/2007
//
// Descrio: Envia o comando para habilitar o beep do terminal
//            Segundo parmetro: (1) ativa e (0) desativa o beep do terminal
//
//********************************************************************************************************

procedure TForm1.btnBeepOnClick(Sender: TObject);
begin
    // Verifica se h algum terminal selecionado
    if (ListBox1.ItemIndex = -1) then
    begin
        Application.MessageBox('Selecione um terminal.','Teclado',48)
    end
    else
    begin
        // Envia o comando de SetBeep para o terminal
        if mt_setbeep(id_selecionado,1) < 1 then
        begin
            Application.MessageBox('Erro enviando comando.','ERRO',16);
        end;
    end;
end;

//********************************************************************************************************
// Evento: btnBeepOffClick
//********************************************************************************************************
//
// Data de Criao: 17/12/2007
//
// Descrio: Envia o comando para desabilitar o beep do terminal
//            Segundo parmetro: (1) ativa e (0) desativa o beep do terminal
//
//********************************************************************************************************

procedure TForm1.btnBeepOffClick(Sender: TObject);
begin
    // Verifica se h algum terminal selecionado
    if (ListBox1.ItemIndex = -1) then
    begin
        Application.MessageBox('Selecione um terminal.','Teclado',48)
    end
    else
    begin
        // Envia o comando de SetBeep para o terminal
        if mt_setbeep(id_selecionado,0) < 1 then
        begin
            Application.MessageBox('Erro enviando comando.','ERRO',16);
        end;
    end;
end;

//********************************************************************************************************
// Evento: btnBeepKeyOnClick
//********************************************************************************************************
//
// Data de Criao: 17/12/2007
//
// Descrio: Envia o comando para habilitar o beep das teclas do terminal
//            Segundo parmetro: (1) ativa e (0) desativa o beep das teclas do terminal
//
//********************************************************************************************************

procedure TForm1.btnBeepKeyOnClick(Sender: TObject);
begin
    // Verifica se h algum terminal selecionado
    if (ListBox1.ItemIndex = -1) then
    begin
        Application.MessageBox('Selecione um terminal.','Teclado',48)
    end
    else
    begin
        // Envia o comando de SetBeepKey para o terminal
        if mt_setbeepkey(id_selecionado,1) < 1 then
        begin
            Application.MessageBox('Erro enviando comando.','ERRO',16);
        end;
    end;
end;

//********************************************************************************************************
// Evento: btnBeepKeyOffClick
//********************************************************************************************************
//
// Data de Criao: 17/12/2007
//
// Descrio: Envia o comando para desabilitar o beep das teclas do terminal
//            Segundo parmetro: (1) ativa e (0) desativa o beep das teclas do terminal
//
//********************************************************************************************************

procedure TForm1.btnBeepKeyOffClick(Sender: TObject);
begin
    // Verifica se h algum terminal selecionado
    if (ListBox1.ItemIndex = -1) then
    begin
        Application.MessageBox('Selecione um terminal.','Teclado',48)
    end
    else
    begin
        // Envia o comando de SetBeepKey para o terminal
        if mt_setbeepkey(id_selecionado,0) < 1 then
        begin
            Application.MessageBox('Erro enviando comando.','ERRO',16);
        end;
    end;
end;

//********************************************************************************************************
// Evento: btnHabilitaSerialClick
//********************************************************************************************************
//
// Data de Criao: 18/12/2007
//
// Descrio: Envia o comando para habilitar a serial selecionada do terminal
//            Terceiro parmetro: (1) ativa e (0) desativa a serial do terminal
//
//********************************************************************************************************

procedure TForm1.btnHabilitaSerialClick(Sender: TObject);
var
    com: BYTE;
begin
    // Verifica se h algum terminal selecionado
    if (ListBox1.ItemIndex = -1) OR (cbPorta.ItemIndex = -1) then
    begin
        Application.MessageBox('Selecione um terminal ou uma porta.','Serial',48)
    end
    else
    begin
        // Selecionando a COM
        com := cbPorta.ItemIndex;
        // Envia o comando de SetEnableSerial para o terminal
        if mt_setenableserial(id_selecionado,com,1) < 1 then
        begin
            Application.MessageBox('Erro enviando comando.','ERRO',16);
        end;
    end;
end;

//********************************************************************************************************
// Evento: btnDesabilitaSerialClick
//********************************************************************************************************
//
// Data de Criao: 18/12/2007
//
// Descrio: Envia o comando para desabilitar a serial selecionada do terminal
//            Terceiro parmetro: (1) ativa e (0) desativa a serial do terminal
//
//********************************************************************************************************

procedure TForm1.btnDesabilitaSerialClick(Sender: TObject);
var
    com: BYTE;
begin
    // Verifica se h algum terminal selecionado
    if (ListBox1.ItemIndex = -1) OR (cbPorta.ItemIndex = -1) then
    begin
        Application.MessageBox('Selecione um terminal ou uma porta.','Serial',48)
    end
    else
    begin
        // Selecionando a COM
        com := cbPorta.ItemIndex;
        // Envia o comando de SetEnableSerial para o terminal
        if mt_setenableserial(id_selecionado,com,0) < 1 then
        begin
            Application.MessageBox('Erro enviando comando.','ERRO',16);
        end;
    end;
end;

//********************************************************************************************************
// Evento: btnGetEnableSerialClick
//********************************************************************************************************
//
// Data de Criao: 18/12/2007
//
// Descrio: Requisita o estado da serial (COM selecionada) no terminal
//
//********************************************************************************************************

procedure TForm1.btnGetEnableSerialClick(Sender: TObject);
var
    com: BYTE;
begin
    // Verifica se h algum terminal selecionado
    if (ListBox1.ItemIndex = -1) OR (cbPorta.ItemIndex = -1) then
    begin
        Application.MessageBox('Selecione um terminal ou uma porta.','Serial',48)
    end
    else
    begin
        // Selecionando a COM
        com := cbPorta.ItemIndex;
        // Requisita o estado do EnableSerial do terminal
        if mt_getenableserial(id_selecionado,com) < 1 then
        begin
            Application.MessageBox('Erro enviando comando.','ERRO',16);
        end;
    end;
end;

//********************************************************************************************************
// Evento: btnSendBinSerialClick
//********************************************************************************************************
//
// Data de Criao: 18/12/2007
//
// Descrio: Envia dados pela serial (COM selecionada) do terminal
//
//********************************************************************************************************

procedure TForm1.btnSendBinSerialClick(Sender: TObject);
var
    com: BYTE;
    tam: BYTE;
    buf: array [0..255] of BYTE;
    i: INTEGER;
    j: INTEGER;
    ok: INTEGER;
begin
    // Verifica se h algum terminal selecionado
    if (ListBox1.ItemIndex = -1) OR (cbPorta.ItemIndex = -1) then
    begin
        Application.MessageBox('Selecione um terminal ou uma porta.','Serial',48)
    end
    else if (rdString.Checked = True) then
    begin
        // Selecionando a COM
        com := cbPorta.ItemIndex;
        // Convertendo o que est na edtSendBinSerial para um vetor de byte
        StrPCopy(@buf,edtSendBinSerial.Text);
        // Recebendo o tamanho do que est no campo edtSendBinSerial
        tam := Length(edtSendBinSerial.Text);
        // Envia o comando de SendBinSerial para o terminal
        if mt_sendbinserial(id_selecionado,com,buf[0],tam) < 1 then
        begin
            Application.MessageBox('Erro enviando comando.','ERRO',16)
        end
        else
        begin
            // Escreve na lista de logs
            ListReceive.Items.Add('IDvSendBinSerial - ' + edtSendBinSerial.Text +  ' - ' + ListBox1.Items.Strings[ListBox1.ItemIndex]);
        end;
    end
    else if (rdByte.Checked = True) then
    begin
        // Selecionando a COM
        com := cbPorta.ItemIndex;
        // Recebendo o tamanho do que est no campo edtSendBinSerial
        tam := Length(edtSendBinSerial.Text);
        // Varivel de controle
        ok := 1;
        // Verifica se h pares de caracter
        if (tam mod 2 <> 0) then
        begin
            Application.MessageBox('Valor incorreto, digite pares de caracteres.','Ateno',48);
        end
        else
        begin
            // Percorre cada posio da string
            i := 0;
            while ((i < tam - 1) and (ok = 1)) do
            begin
                // Verifica se o usurio digitou valores vlidos ('0' at '9' e de 'A' at 'F')
                if (compara(Copy(edtSendBinSerial.Text,i,1))) <> 1 then
                begin
                    Application.MessageBox('Valor incorreto, digite os caracteres entre 0 e 9 ou A e F.','Ateno',48);
                    ok := 0;
                end;
                i := i + 1;
            end;
            // Verifica se  possvel realizar a convero
            if (ok = 1) then
            begin
                j := 1;
                // Armazena cada dois caracteres da string no vetor buf
                for i := 0 to ((tam div 2) - 1) do
                begin
                    // Converte os nmeros de decimal para hexadecimal
                    buf[i] := converte(Copy(edtSendBinSerial.Text,j,2));
                    j := j + 2;
                end;
                // Envia o comando de SendBinSerial para o terminal
                if mt_sendbinserial(id_selecionado,com,buf[0],(tam div 2)) < 1 then
                begin
                    Application.MessageBox('Erro enviando comando.','ERRO',16)
                end
                else
                begin
                    // Escreve na lista de logs
                    ListReceive.Items.Add('IDvSendBinSerial - ' + edtSendBinSerial.Text + ' - ' + ListBox1.Items.Strings[ListBox1.ItemIndex]);
                end;
            end;
        end;
    end
    else
    begin
        Application.MessageBox('Selecione a opo Palavra ou Byte.','Ateno',48);
    end;
end;

//********************************************************************************************************
// Evento: btnEnviarConfSerialClick
//********************************************************************************************************
//
// Data de Criao: 18/12/2007
//
// Descrio: Envia a configurao da serial (COM selecionada) do terminal
//
//********************************************************************************************************

procedure TForm1.btnEnviarConfSerialClick(Sender: TObject);
var
    config: TSetupSerial;
    configuracao: ARG_COM_SETUPSERIAL;
begin
    Try
    // Verifica se h algum terminal selecionado
    if (ListBox1.ItemIndex = -1) OR (cbPorta.ItemIndex = -1) then
    begin
        Application.MessageBox('Selecione um terminal ou uma porta.','Serial',48)
    end
    else
    begin
        // Selecionando a COM
        configuracao.com := cbPorta.ItemIndex;

        // Recebendo toda configurao da serial
        config.baud := StrToInt(cbBaud.Text);
        config.bits := StrToInt(cbBits.Text);

        if cbParidade.Text = ('Nenhum') then
            config.parity := 0
        else if cbParidade.Text = ('Impar') then
            config.parity := 1
        else if cbParidade.Text = ('Par') then
            config.parity := 2
        else if cbParidade.Text = ('Marca') then
            config.parity := 3
        else if cbParidade.Text = ('Espao')then
            config.parity := 4;

        config.stops := StrToInt(cbStop.Text);

        if cbHand.Text = ('Nenhum') then
        begin
            config.handshaking := 0;
        end
        else
        begin
            config.handshaking := 1;
        end;

        configuracao.Setup := config;

        // Envia configurao para o terminal
        if mt_sendconfigserial(id_selecionado,configuracao) < 1 then
        begin
            Application.MessageBox('Erro enviando comando.','ERRO',16);
        end
        else
        begin
            // Escreve na lista de logs
            ListReceive.Items.Add('IDvSetSetupSerial - ' + ListBox1.Items.Strings[ListBox1.ItemIndex]);
            Sleep(50);
            mt_restart(id_selecionado);
        end;
    end;
    Except
        Application.MessageBox('Preencha corretamente os campos.','Serial',16);
    end;
end;

//********************************************************************************************************
// Evento: btnRecebeConfSerialClick
//********************************************************************************************************
//
// Data de Criao: 18/12/2007
//
// Descrio: Requisita a configurao da serial (COM selecionada) do terminal
//
//********************************************************************************************************

procedure TForm1.btnRecebeConfSerialClick(Sender: TObject);
var
    com: BYTE;
begin
    // Verifica se h algum terminal selecionado
    if (ListBox1.ItemIndex = -1) OR (cbPorta.ItemIndex = -1) then
    begin
        Application.MessageBox('Selecione um terminal ou uma porta.','Serial',48)
    end
    else
    begin
        com := cbPorta.ItemIndex;
        // Requisita a configurao da serial do terminal
        if mt_reqconfigserial(id_selecionado,com) < 1 then
        begin
            Application.MessageBox('Erro enviando comando.','ERRO',16);
        end;
    end;
end;

//********************************************************************************************************
// Evento: rdAtivaByteClick
//********************************************************************************************************
//
// Data de Criao: 19/12/2007
//
// Descrio: Envia o comando para ativar o byte terminador da porta serial
//            Quarto parmetro: (1) ativa e (0) desativa o byte terminador da porta serial do terminal
//
//********************************************************************************************************

procedure TForm1.rdAtivaByteClick(Sender: TObject);
var
    com: BYTE;
begin
    // Verifica se h algum terminal selecionado
    if (ListBox1.ItemIndex = -1) OR (cbPorta.ItemIndex = -1) then
    begin
        Application.MessageBox('Selecione um terminal ou uma porta.','Serial',48);
        rdAtivaByte.Checked := False;
        rdDesativaByte.Checked := False;
    end
    else
    begin
        com := cbPorta.ItemIndex;
        // Configura o caracter terminador da porta serial ao enviar o coamando IDvSetTermSerial para o terminal
        if mt_settermserial(id_selecionado,com,StrToInt(edtByte.Text),1) < 1 then
        begin
            Application.MessageBox('Erro enviando comando.','ERRO',16);
        end
        else
        begin
            // Escreve na lista de logs
            ListReceive.Items.Add('ByteTerminador - ' + edtByte.Text + ' - Ativo - ' + ListBox1.Items.Strings[ListBox1.ItemIndex]);
        end;
    end;
end;

//********************************************************************************************************
// Evento: rdDesativaByteClick
//********************************************************************************************************
//
// Data de Criao: 19/12/2007
//
// Descrio: Envia o comando para desativar o byte terminador da porta serial
//            Quarto parmetro: (1) ativa e (0) desativa o byte terminador da porta serial do terminal
//
//********************************************************************************************************

procedure TForm1.rdDesativaByteClick(Sender: TObject);
var
    com: BYTE;
begin
    // Verifica se h algum terminal selecionado
    if (ListBox1.ItemIndex = -1) OR (cbPorta.ItemIndex = -1) then
    begin
        Application.MessageBox('Selecione um terminal ou uma porta.','Serial',48);
        rdAtivaByte.Checked := False;
        rdDesativaByte.Checked := False;
    end
    else
    begin
        com := cbPorta.ItemIndex;
        // Configura o caracter terminador da porta serial ao enviar o coamando IDvSetTermSerial para o terminal
        if mt_settermserial(id_selecionado,com,StrToInt(edtByte.Text),0) < 1 then
        begin
            Application.MessageBox('Erro enviando comando.','ERRO',16);
        end
        else
        begin
            // Escreve na lista de logs
            ListReceive.Items.Add('ByteTerminador - ' + edtByte.Text + ' - Desativo - ' + ListBox1.Items.Strings[ListBox1.ItemIndex]);
        end;
    end;
end;

//********************************************************************************************************
// Evento: btnSolicitaPesoClick
//********************************************************************************************************
//
// Data de Criao: 19/12/2007
//
// Descrio: Envia o byte 05 para serial (COM selecionada) do terminal requisitando o peso da balana
//            
//********************************************************************************************************

procedure TForm1.btnSolicitaPesoClick(Sender: TObject);
var
    com: DWORD;
    buf: array [0..255] of BYTE;
begin
    // Verifica se h algum terminal selecionado
    if (ListBox1.ItemIndex = -1) OR (cbPorta.ItemIndex = -1) then
    begin
        Application.MessageBox('Selecione um terminal ou uma porta.','Serial',48)
    end
    else
    begin
        // Selecionando a COM
        com := cbPorta.ItemIndex;
        buf[0] := 5;
        // Envia o comando de SendBinSerial para o terminal
        if mt_sendbinserial(id_selecionado,com,buf[0],1) < 1 then
        begin
            Application.MessageBox('Erro enviando comando.','ERRO',16);
        end;
    end;
end;

//********************************************************************************************************
// Evento: btnHabilitarCartaoClick
//********************************************************************************************************
//
// Data de Criao: 19/12/2007
//
// Descrio: Envia o comando para habilitar o carto magntico do terminal
//            Segundo parmetro: (1) ativa e (0) desativa o carto magntico do terminal
//
//********************************************************************************************************

procedure TForm1.btnHabilitarCartaoClick(Sender: TObject);
begin
    // Verifica se h algum terminal selecionado
    if (ListBox1.ItemIndex = -1) then
    begin
        Application.MessageBox('Selecione um terminal.','Carto',48)
    end
    else
    begin
        // Envia o comando de SetCard para o terminal
        if mt_sendsetcard(id_selecionado,1) < 1 then
        begin
            Application.MessageBox('Erro enviando comando.','ERRO',16);
        end;
    end;
end;

//********************************************************************************************************
// Evento: btnDesabilitarCartaoClick
//********************************************************************************************************
//
// Data de Criao: 19/12/2007
//
// Descrio: Envia o comando para desabilitar o carto magntico do terminal
//            Segundo parmetro: (1) ativa e (0) desativa o carto magntico do terminal
//
//********************************************************************************************************

procedure TForm1.btnDesabilitarCartaoClick(Sender: TObject);
begin
    // Verifica se h algum terminal selecionado
    if (ListBox1.ItemIndex = -1) then
    begin
        Application.MessageBox('Selecione um terminal.','Carto',48)
    end
    else
    begin
        // Envia o comando de SetCard para o terminal
        if mt_sendsetcard(id_selecionado,0) < 1 then
        begin
            Application.MessageBox('Erro enviando comando.','ERRO',16);
        end;
    end;
end;

//********************************************************************************************************
// Evento: btnGetCardClick
//********************************************************************************************************
//
// Data de Criao: 19/12/2007
//
// Descrio: Requisita o estado do carto magntico do terminal
//
//********************************************************************************************************

procedure TForm1.btnGetCardClick(Sender: TObject);
begin
    // Verifica se h algum terminal selecionado
    if (ListBox1.ItemIndex = -1) then
    begin
        Application.MessageBox('Selecione um terminal.','Carto',48)
    end
    else
    begin
        // Requisita o estado do carto magntico do terminal
        if mt_reqgetcard(id_selecionado) < 1 then
        begin
            Application.MessageBox('Erro enviando comando.','ERRO',16);
        end;
    end;
end;

//********************************************************************************************************
// Evento: btnGrava44Click
//********************************************************************************************************
//
// Data de Criao: 20/12/2007
//
// Descrio: Envia o comando para realizar a programao do teclado
//
//********************************************************************************************************

procedure TForm1.btnGrava44Click(Sender: TObject);
var
    buf: array [0..511] of BYTE;

    ofs : _OFSTRUCT;
    // BytesRead: DWORD;
    handle: DWORD;

    arquivo: TextFile;
    palavra: String;
    numero: Integer;
    i: Integer;
begin
    Try
    // BytesRead := 0
    handle := 0;
    i := 1;

    // Abre uma caixa de dialogo padro do windows
    OpenDialog1.InitialDir := ExtractFilePath(ParamStr(0));
    if (OpenDialog1.Execute = True) then
    begin
        handle := OpenFile(PChar(OpenDialog1.FileName), ofs, OF_READ);
    end;
    if (handle < 0) then
    begin
        Application.MessageBox('Erro abrindo arquivo.','ERRO',16);
    end
    else
    begin
        // Abre o arquivo .gtc
        AssignFile(arquivo, OpenDialog1.FileName);
        Reset(arquivo);
        while i <= 512 do
        begin
            // L cada linha do arquivo e armazena na varivel 'palavra'
            ReadLn(arquivo,palavra);
            // Converte a String (varivel palavra) para Integer (varivel numero)
            numero := StrToInt(palavra);
            // Converte Integer (varivel numero) para StringEmHexadecimal (varivel palavra)
            //palavra := IntToHex(numero, 2);
            // Converte StringEmHexadecimal (varivel palavra) para NumeroEmHexadecimal (varivel numro)
            //numero := StrToInt('$' + palavra);
            // Armazena cada Hexadecimal (varivel numero) em uma posio do vetor (varivel buf)
            buf[i - 1] := numero;
            i := i + 1;
        end;
        CloseHandle(handle);
    end;

    // Envia o comando de ProgramKeyboard para o terminal
    if mt_programkbd(id_selecionado,buf[0]) < 1 then
    begin
        Application.MessageBox('Erro enviando comando.','ERRO',16)
    end
    else
    begin
        ListReceive.Items.Add('IDbProgramKbd - ' + ListBox1.Items.Strings[ListBox1.ItemIndex]);
        Sleep(50);
        mt_restart(id_selecionado);
    end;
    Except
        Application.MessageBox('A operao foi cancelada.','Gravar',48);
    end;
end;

//********************************************************************************************************
// Evento: btnGrava20Click
//********************************************************************************************************
//
// Data de Criao: 20/12/2007
//
// Descrio: Envia o comando para realizar a programao do teclado
//
//********************************************************************************************************

procedure TForm1.btnGrava20Click(Sender: TObject);
var
    buf: array [0..511] of BYTE;
    bufOut: array [0..511] of BYTE;

    ofs : _OFSTRUCT;
    // BytesRead: DWORD;
    handle: DWORD;

    page: DWORD;
    currpage: DWORD;
    line: DWORD;
    currline: DWORD;
    i: DWORD;

    ptr: PChar;
    ptrOut: PChar;

    arquivo: TextFile;
    palavra: String;
    numero: Integer;
begin
    Try
    // BytesRead := 0;
    handle := 0;
    i := 1;

    // Abre uma caixa de dialogo padro do windows
    OpenDialog1.InitialDir := ExtractFilePath(ParamStr(0));
    if (OpenDialog1.Execute = True) then
    begin
        handle := OpenFile(PChar(OpenDialog1.FileName), ofs, OF_READ);
    end;
    if (handle < 0) then
    begin
        Application.MessageBox('Erro abrindo arquivo.','ERRO',16);
    end
    else
    begin
        // Abre o arquivo .gtc
        AssignFile(arquivo, OpenDialog1.FileName);
        Reset(arquivo);
        while i <= 512 do
        begin
            // L cada linha do arquivo e armazena na varivel 'palavra'
            ReadLn(arquivo,palavra);
            // Converte a String (varivel palavra) para Integer (varivel numero)
            numero := StrToInt(palavra);
            // Converte Integer (varivel numero) para StringEmHexadecimal (varivel palavra)
            //palavra := IntToHex(numero, 2);
            // Converte StringEmHexadecimal (varivel palavra) para NumeroEmHexadecimal (varivel numro)
            //numero := StrToInt('$' + palavra);
            // Armazena cada Hexadecimal (varivel numero) em uma posio do vetor (varivel buf)
            buf[i - 1] := numero;
            i := i + 1;
        end;
        CloseHandle(handle);
    end;

    // Transladar bytes
    for page := 0 to 4 do
    begin
        currpage := page * 128;
        for line := 0 to 4 do
        begin
            currline := line * 16;
            ptr := @buf[currpage + 48 - currline];
            ptrOut := @bufOut[currpage + currline];

            for i := 0 to 4 do
            begin
                 ptrOut[i] := ptr[4 - i];
            end;
        end;
    end;

    // Envia o comando de ProgramKeyboard para o terminal
    if mt_programkbd(id_selecionado,bufOut[0]) < 1 then
    begin
        Application.MessageBox('Erro enviando comando.','ERRO',16)
    end
    else
    begin
        ListReceive.Items.Add('IDbProgramKbd - ' + ListBox1.Items.Strings[ListBox1.ItemIndex]);
        Sleep(50);
        mt_restart(id_selecionado);
    end;
    Except
        Application.MessageBox('A operao foi cancelada.','Gravar',48);
    end;
end;

//********************************************************************************************************
// Evento: Timer2Timer
//********************************************************************************************************
//
// Data de Criao: 13/05/2008
//
// Descrio: Seleciona o id para qual os comandos realizados pelo usurio sero enviados
//
//********************************************************************************************************

procedure TForm1.Timer2Timer(Sender: TObject);
var
   i, controle: Integer;
   id_vetor, id_listbox: String;
begin
    i := 0;
    controle := 0;
    while i < 255 do
    begin
        if ((tabcon.TSOCK[i] <> 0) And (ListBox1.Items.Text <> '') And (controle = 0)) then
        begin
            // Transforma o ID em um endereo vlido.
            auxIP.S_addr := tabcon.TSOCK[i];
            id_vetor := inet_ntoa(auxIP) + ' - ' + IntToStr(i);

            // Recebe o texto do item selecionado na lista.
            id_listbox := ListBox1.Items.Strings[ListBox1.ItemIndex];

            // Realiza a comparao para verificar ip contido no vetor e o mesmo
            // ip do item selecionado na lista. Se sim qualquer comando enviado
            // ser com o id do terminal selecionado na lista.
            if (id_vetor = id_listbox) then
            begin
                id_selecionado := i;
                controle := 1;
            end;
        end;
        i := i + 1;
    end;

    // Atualiza para que a listbox mostre o ltimo comando enviado
    SendMessage(ListReceive.Handle, WM_VSCROLL, SB_BOTTOM, 0);
end;

end.
